#include <stdio.h>
#include <inttypes.h>

#define TRUE  ( 1 )
#define FALSE ( 0 )

int test_even( int x )
{
	if( x & 1 ){
		return FALSE; /* odd */
	} else {
		return TRUE; /* even */
	}
}

int test_bit_set( uint32_t x, uint8_t bit )
{
	if( ( x & ( 1 << bit ) ) ){
		return TRUE;
	} else {
		return FALSE;
	}
}

int set_nth_bit( uint32_t x, uint8_t bit )
{
	return ( x | ( 1 << bit ) );
}

int main( int argc, char* argv[] )
{
	// even / odd
	printf( "%d is %s\n", 2, test_even( 2 )?"EVEN":"ODD" );
	printf( "%d is %s\n", 3, test_even( 3 )?"EVEN":"ODD" );
	
	// bit test 
	printf( "Bit %d is %s in %d\n", 0, test_bit_set( 3, 0 )?"set":"not set", 3 );
	printf( "Bit %d is %s in %d\n", 1, test_bit_set( 3, 1 )?"set":"not set", 3 );
	printf( "Bit %d is %s in %d\n", 2, test_bit_set( 3, 2 )?"set":"not set", 3 );

	int x = 0;
	x |= ( 1 << 0 ); /* set 0th bit - x: 0x0001 */
	                 /* Todo: set 1th bit - x: 0x0003*/
	                 /* Todo: set 2th bit - x: 0x0007*/
	                 /* Todo: set 3th bit - x: 0x000F*/
	printf( "x = 0x%04x\n", x );

	x &= ~( 1 << 0 ); /* unset bit 0 */ 
	                  /* Todo: unset bit 1 */ 
	                  /* Todo: unset bit 2 */ 
	                  /* Todo: unset bit 3 */ 
	printf( "x = 0x%04x\n", x );

	// toggle bit
	x ^= ( 1 << 0 ); /* toggle bit 0 */ 
	                 /* Todo: toggle bit 1 */ 
	                 /* Todo: toggle bit 2 */ 
	                 /* Todo: toggle bit 3 */ 

	return 0;
}
